"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.editEmbedSmartLinkUrlTestCase = exports.editEmbedSmartLinkTitleTestCase = void 0;
var _inProductTesting = require("@atlaskit/in-product-testing");
var _inProduct = require("@atlaskit/smart-card/in-product");
var _Editor = require("../../../../page-objects/Editor");
var _EditorSmartLink = require("../../../../page-objects/EditorSmartLink");
var editEmbedSmartLinkTitleTestCase = exports.editEmbedSmartLinkTitleTestCase = function editEmbedSmartLinkTitleTestCase(_ref) {
  var ui = _ref.ui,
    url = _ref.url;
  return new _inProductTesting.InProductTestCase({
    title: 'editing an Embed Smart Link renders as Blue Link (title)',
    id: 'embed-smart-link-edit-title',
    assertions: function assertions(cy) {
      var editor = new _Editor.EditorPageObject(cy);
      var editorWithSmartLinks = new _EditorSmartLink.EditorSmartLinkPageObject(cy, editor);
      var embedCard = new _inProduct.EmbedCardPageObject(cy);
      editorWithSmartLinks.insertSmartLinkByTyping(url);
      editorWithSmartLinks.switchAfterInsert('embed');
      (0, _inProduct.embedSmartLinkRendersTestCase)({
        url: url
      }).assertions(cy);
      editorWithSmartLinks.changeLinkLabel('Avocorne is watching you 🥑', 'embed');
      embedCard.assertHrefRendered(url);
      embedCard.expectCardNotExists();
      if (ui !== null && ui !== void 0 && ui.publishButton) {
        var renderer = editor.publish(ui);
        renderer.expectContentReady();
        embedCard.assertHrefRendered(url);
        embedCard.expectCardNotExists();
      }
    }
  });
};
var editEmbedSmartLinkUrlTestCase = exports.editEmbedSmartLinkUrlTestCase = function editEmbedSmartLinkUrlTestCase(_ref2) {
  var ui = _ref2.ui,
    url = _ref2.url;
  return new _inProductTesting.InProductTestCase({
    title: 'editing an Embed Smart Link renders as Blue Link (URL)',
    id: 'embed-smart-link-edit',
    assertions: function assertions(cy) {
      var editor = new _Editor.EditorPageObject(cy);
      var editorWithSmartLinks = new _EditorSmartLink.EditorSmartLinkPageObject(cy, editor);
      var embedCard = new _inProduct.EmbedCardPageObject(cy);
      editorWithSmartLinks.insertSmartLinkByTyping(url);
      editorWithSmartLinks.switchAfterInsert('embed');
      (0, _inProduct.embedSmartLinkRendersTestCase)({
        url: url
      }).assertions(cy);
      var newUrl = 'https://avo.corne.com';
      editorWithSmartLinks.changeLinkUrl(newUrl, 'embed');
      embedCard.expectCardNotExists();
      embedCard.assertHrefRendered(newUrl);
      if (ui !== null && ui !== void 0 && ui.publishButton) {
        var renderer = editor.publish(ui);
        renderer.expectContentReady();
        embedCard.assertHrefRendered(newUrl);
        embedCard.expectCardNotExists();
      }
    }
  });
};