"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.editInlineSmartLinkUrlTestCase = exports.editInlineSmartLinkTitleTestCase = void 0;
var _inProductTesting = require("@atlaskit/in-product-testing");
var _inProduct = require("@atlaskit/smart-card/in-product");
var _Editor = require("../../../../page-objects/Editor");
var _EditorSmartLink = require("../../../../page-objects/EditorSmartLink");
var editInlineSmartLinkTitleTestCase = exports.editInlineSmartLinkTitleTestCase = function editInlineSmartLinkTitleTestCase(_ref) {
  var ui = _ref.ui,
    url = _ref.url;
  return new _inProductTesting.InProductTestCase({
    title: 'editing an Inline Smart Link renders as Blue Link (title)',
    id: 'inline-smart-link-edit-title',
    assertions: function assertions(cy) {
      var editor = new _Editor.EditorPageObject(cy);
      var editorWithSmartLinks = new _EditorSmartLink.EditorSmartLinkPageObject(cy, editor);
      var inlineCard = new _inProduct.InlineCardPageObject(cy);
      editorWithSmartLinks.insertSmartLinkByTyping(url);
      (0, _inProduct.inlineSmartLinkRendersTestCase)({
        url: url
      }).assertions(cy);
      editorWithSmartLinks.changeLinkLabel('Avocorne is watching you 🥑');
      inlineCard.assertHrefRendered(url);
      inlineCard.expectCardNotExists();
      if (ui !== null && ui !== void 0 && ui.publishButton) {
        var renderer = editor.publish(ui);
        renderer.expectContentReady();
        inlineCard.assertHrefRendered(url);
        inlineCard.expectCardNotExists();
      }
    }
  });
};
var editInlineSmartLinkUrlTestCase = exports.editInlineSmartLinkUrlTestCase = function editInlineSmartLinkUrlTestCase(_ref2) {
  var ui = _ref2.ui,
    url = _ref2.url;
  return new _inProductTesting.InProductTestCase({
    title: 'editing an Inline Smart Link renders as Blue Link (URL)',
    id: 'inline-smart-link-edit',
    assertions: function assertions(cy) {
      var editor = new _Editor.EditorPageObject(cy);
      var editorWithSmartLinks = new _EditorSmartLink.EditorSmartLinkPageObject(cy, editor);
      var inlineCard = new _inProduct.InlineCardPageObject(cy);
      editorWithSmartLinks.insertSmartLinkByTyping(url);
      (0, _inProduct.inlineSmartLinkRendersTestCase)({
        url: url
      }).assertions(cy);
      var newUrl = 'https://avo.corne.com';
      editorWithSmartLinks.changeLinkUrl(newUrl);
      inlineCard.expectCardNotExists();
      inlineCard.assertHrefRendered(newUrl);
      if (ui !== null && ui !== void 0 && ui.publishButton) {
        var renderer = editor.publish(ui);
        renderer.expectContentReady();
        inlineCard.assertHrefRendered(newUrl);
        inlineCard.expectCardNotExists();
      }
    }
  });
};