"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = IconTable;
var _react = _interopRequireDefault(require("react"));
var _useIconThemed2 = require("../../quick-insert/use-icon-themed");
/* eslint-disable @atlaskit/design-system/ensure-design-token-usage */

function IconTable() {
  var _useIconThemed = (0, _useIconThemed2.useIconThemed)(),
    iconThemed = _useIconThemed.iconThemed;
  var cellBackgroundColour = iconThemed({
    light: '#FFF',
    dark: '#1D2125'
  });
  var headerBackgroundColour = iconThemed({
    light: '#DFE1E6',
    dark: '#5A6977'
  });
  return /*#__PURE__*/_react.default.createElement("svg", {
    focusable: "false",
    "aria-hidden": true,
    width: 40,
    height: 40
  }, /*#__PURE__*/_react.default.createElement("g", {
    fill: "none",
    fillRule: "evenodd"
  }, /*#__PURE__*/_react.default.createElement("path", {
    fill: iconThemed({
      light: '#FFF',
      dark: '#161A1D'
    }),
    d: "M0 0h40v40H0z"
  }), /*#__PURE__*/_react.default.createElement("g", {
    stroke: iconThemed({
      light: '#C1C7D0',
      dark: '#454F59'
    })
  }, /*#__PURE__*/_react.default.createElement("path", {
    fill: cellBackgroundColour,
    d: "M20 16h14v8H20z"
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M20 8h13a1 1 0 011 1v7H20V8z",
    fill: headerBackgroundColour
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M20 24h14v7a1 1 0 01-1 1H20v-8zM6 16h14v8H6z",
    fill: cellBackgroundColour
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M7 8h13v8H6V9a1 1 0 011-1z",
    fill: headerBackgroundColour
  }), /*#__PURE__*/_react.default.createElement("path", {
    d: "M6 24h14v8H7a1 1 0 01-1-1v-7z",
    fill: cellBackgroundColour
  }))));
}