"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.referenceHeights = exports.DEFAULT_INLINE_IMAGE_BORDER_SIZE = exports.DEFAULT_INLINE_IMAGE_ASPECT_RATIO = exports.DEFAULT_IMAGE_WIDTH = exports.DEFAULT_IMAGE_HEIGHT = void 0;
var _typography = require("@atlaskit/theme/typography");
var DEFAULT_IMAGE_WIDTH = exports.DEFAULT_IMAGE_WIDTH = 250;
var DEFAULT_IMAGE_HEIGHT = exports.DEFAULT_IMAGE_HEIGHT = 200;
var DEFAULT_INLINE_IMAGE_ASPECT_RATIO = exports.DEFAULT_INLINE_IMAGE_ASPECT_RATIO = DEFAULT_IMAGE_WIDTH / DEFAULT_IMAGE_HEIGHT;
var DEFAULT_INLINE_IMAGE_BORDER_SIZE = exports.DEFAULT_INLINE_IMAGE_BORDER_SIZE = 0;

/**
 * Reference Heights
 *
 * These heights enforce consistent sizes with media inline nodes due to
 * inconsistencies with center aligned inline nodes and text.
 *
 * There is conversation about refactoring media inline nodes to conform to
 * aligning correctly with the surrounding text.
 */
var referenceHeights = exports.referenceHeights = {
  p: _typography.headingSizes.h600.lineHeight - 2,
  h1: _typography.headingSizes.h800.lineHeight + 4,
  h2: _typography.headingSizes.h700.lineHeight + 3,
  h3: _typography.headingSizes.h600.lineHeight + 1,
  h4: _typography.headingSizes.h500.lineHeight + 3,
  h5: _typography.headingSizes.h400.lineHeight + 4,
  h6: _typography.headingSizes.h300.lineHeight + 2
};