/** @jsx jsx */
import React from 'react';
import { jsx } from '@emotion/react';
import type { RichMediaLayout as MediaSingleLayout } from '@atlaskit/adf-schema';
import type { MediaSingleSize, MediaSingleWidthType } from './types';
export interface Props {
    children: React.ReactNode;
    layout: MediaSingleLayout;
    width?: number;
    height: number;
    lineLength: number;
    containerWidth?: number;
    isLoading?: boolean;
    className?: string;
    /**
     * @private
     * @deprecated Use {@link Props.size.width} instead.
     * Cleanup ticket: https://product-fabric.atlassian.net/browse/ED-19076
     */
    pctWidth?: number;
    size?: MediaSingleSize;
    nodeType?: string;
    fullWidthMode?: boolean;
    hasFallbackContainer?: boolean;
    handleMediaSingleRef?: React.RefObject<HTMLDivElement>;
    isInsideOfInlineExtension?: boolean;
    dataAttributes?: Record<string, any>;
}
export type { MediaSingleWidthType, MediaSingleSize };
export default function MediaSingle({ layout, width, height, containerWidth, isLoading, pctWidth, size, className, children: propsChildren, nodeType, fullWidthMode, lineLength: editorWidth, hasFallbackContainer, handleMediaSingleRef, isInsideOfInlineExtension, dataAttributes, }: Props): jsx.JSX.Element;
